"use strict";
// import "pdfjs-dist/web/pdf_viewer.css";
// import "../style/pdf_viewer.css";
// import "../style/PdfHighlighter.css";
// import {
//   EventBus,
//   NullL10n,
//   PDFLinkService,
//   PDFViewer,
// } from "pdfjs-dist/legacy/web/pdf_viewer";
// import type {
//   IHighlight,
//   LTWH,
//   LTWHP,
//   Position,
//   Scaled,
//   ScaledPosition,
// } from "../types";
// import React, { PointerEventHandler, PureComponent, RefObject, useEffect, useRef } from "react";
// import {
//   asElement,
//   findOrCreateContainerLayer,
//   getPageFromElement,
//   getPagesFromRange,
//   getWindow,
//   isHTMLElement,
// } from "../lib/pdfjs-dom";
// import { scaledToViewport, viewportToScaled } from "../lib/coordinates";
// import MouseSelection from "./MouseSelection";
// import type { PDFDocumentProxy } from "pdfjs-dist";
// import TipContainer from "./TipContainer";
// import { createRoot, Root } from "react-dom/client";
// import debounce from "lodash.debounce";
// import getAreaAsPng from "../lib/get-area-as-png";
// import getBoundingRect from "../lib/get-bounding-rect";
// import getClientRects from "../lib/get-client-rects";
// import { HighlightLayer } from "./HighlightLayer";
// export type T_ViewportHighlight<T_HT> = { position: Position } & T_HT;
// interface State<T_HT> {
//   ghostHighlight: {
//     position: ScaledPosition;
//     content?: { text?: string; image?: string };
//   } | null;
//   isCollapsed: boolean;
//   range: Range | null;
//   tip: {
//     highlight: T_ViewportHighlight<T_HT>;
//     callback: (highlight: T_ViewportHighlight<T_HT>) => JSX.Element;
//   } | null;
//   tipPosition: Position | null;
//   tipChildren: JSX.Element | null;
//   isAreaSelectionInProgress: boolean;
//   scrolledToHighlightId: string;
//   selectedHighlight: any;
// }
// interface Props<T_HT> {
//   highlightTransform: (
//     highlight: T_ViewportHighlight<T_HT>,
//     index: number,
//     setTip: (
//       highlight: T_ViewportHighlight<T_HT>,
//       callback: (highlight: T_ViewportHighlight<T_HT>) => JSX.Element
//     ) => void,
//     hideTip: () => void,
//     viewportToScaled: (rect: LTWHP) => Scaled,
//     screenshot: (position: LTWH) => string,
//     isScrolledTo: boolean
//   ) => JSX.Element;
//   highlights: Array<T_HT>;
//   onScrollChange: () => void;
//   scrollRef: (scrollTo: (highlight: T_HT) => void) => void;
//   pdfDocument: PDFDocumentProxy;
//   pdfScaleValue: string;
//   onSelectionFinished: (
//     position: ScaledPosition,
//     content: { text?: string; image?: string },
//     hideTipAndSelection: () => void,
//     transformSelection: () => void
//   ) => JSX.Element | null;
//   enableAreaSelection: (event: MouseEvent) => boolean;
//   areaRemove: boolean;
//   setNewHighlight: (highlight: any) => void;
//   setHighlightIds: (highlightIds: any) => void;
// }
// const EMPTY_ID = "empty-id";
// export function PdfHighlighter<T_HT extends IHighlight>({
//   pdfDocument,
//   onScrollChange,
//   scrollRef,
//   pdfScaleValue,
//   onSelectionFinished,
//   enableAreaSelection,
//   areaRemove,
//   setNewHighlight,
//   setHighlightIds,
//   highlights,
//   highlightTransform,
// }: Props<T_HT>) {
//   const containerRef = React.createRef<HTMLDivElement>();
//   const viewerRef = React.createRef<HTMLDivElement>();
//   const [state, setState] = React.useState<State<T_HT>>({
//     ghostHighlight: null,
//     isCollapsed: true,
//     range: null,
//     tip: null,
//     tipPosition: null,
//     tipChildren: null,
//     isAreaSelectionInProgress: false,
//     scrolledToHighlightId: EMPTY_ID,
//     selectedHighlight: null,
//   });
//   const unsubscribe = () => {};
//   const resetSelection = () => {
//     setState({
//       ...state,
//       ghostHighlight: null,
//       isCollapsed: true,
//       range: null,
//       tip: null,
//       tipPosition: null,
//       tipChildren: null,
//     });
//   };
//   const createTip = (
//     highlight: T_ViewportHighlight<T_HT>,
//     callback: (highlight: T_ViewportHighlight<T_HT>) => JSX.Element
//   ) => {
//     setState({
//       ...state,
//       tipPosition: highlight.position,
//       tipChildren: callback(highlight),
//       tip: { highlight, callback },
//     });
//   };
//   const hideTipAndSelection = () => {
//     setState({
//       ...state,
//       ghostHighlight: null,
//       tipPosition: null,
//       tipChildren: null,
//       tip: null,
//     });
//   };
//     const viewer = useRef<PDFViewer>(null);
//     const eventBus = new EventBus();
//     const linkService = new PDFLinkService({ eventBus, externalLinkTarget: 2 });
//     const containerNode = useRef<HTMLDivElement>(null);
//     const highlightRoots = useRef<Record<number, { reactRoot: Root; container: Element }>>({});
//     const resizeObserver = useRef<ResizeObserver | null>(null);
//     useEffect(() => {
//         const container = containerNode.current;
//         if (!container) {
//             return;
//         }
//         const { ownerDocument } = container;
//         if (!ownerDocument) {
//             return;
//         }
//         const { defaultView } = ownerDocument;
//         if (!defaultView) {
//             return;
//         }
//         const handleResize = debounce(() => {
//             eventBus.dispatch("resize", { source: container });
//         }, 300);
//         resizeObserver.current = new defaultView.ResizeObserver(handleResize);
//         resizeObserver.current.observe(container);
//         return () => {
//             if (resizeObserver.current) {
//             resizeObserver.current.disconnect();
//             }
//         };
//         }, [eventBus]);
//         const attachRef = () => {
//             // const containerNode = containerNodeRef.current;
//             const { ownerDocument: doc } = containerNode;
//             // Assuming you have unsubscribe logic in a separate function
//             unsubscribe();
//             if (containerNode) {
//               eventBus.on("textlayerrendered", onTextLayerRendered);
//               eventBus.on("pagesinit", onDocumentReady);
//               doc.addEventListener("selectionchange", onSelectionChange);
//               doc.addEventListener("keydown", handleKeyDown);
//               doc.defaultView?.addEventListener("resize", debouncedScaleValue);
//               if (resizeObserver.current) {
//                 resizeObserver.current.observe(containerNode);
//               }
//               // Update your unsubscribe function
//               const unsubscribe = () => {
//                 eventBus.off("pagesinit", onDocumentReady);
//                 eventBus.off("textlayerrendered", onTextLayerRendered);
//                 doc.removeEventListener("selectionchange", onSelectionChange);
//                 doc.removeEventListener("keydown", handleKeyDown);
//                 doc.defaultView?.removeEventListener("resize", debouncedScaleValue);
//                 if (resizeObserver.current) {
//                   resizeObserver.current.disconnect();
//                 }
//               };
//             }
//           };
//           const init = () => {
//             // Destructure pdfDocument from props
//             // The following lines replace `this.attachRef();`
//             // Assume that you have the `attachRef` function defined in your functional component
//             attachRef();
//             // Initialize the PDF viewer if it hasn't been initialized yet
//             if (!viewer.current) {
//               viewer. = new PDFViewer({
//                 // container: containerNode!,
//                 eventBus: eventBus,
//                 textLayerMode: 2,
//                 removePageBorders: true,
//                 linkService: linkService,
//                 l10n: NullL10n,
//               });
//             }
//             linkService.setDocument(pdfDocument);
//             linkService.current.setViewer(viewer.current);
//             viewer.current.setDocument(pdfDocument);
//             // For debug purposes
//             (window as any).PdfViewer = viewer.current;
//           };
//# sourceMappingURL=PdfHighlighter1.js.map